/*
Character Counter Widget
Rob Allegretti
7-16-2019
*/


define(function() {

  var imposeMaxLength = function(textbox, maxLength) {
       if (textbox.val().length > maxLength) {
           textbox.val(textbox.val().substring(0, maxLength));
       }
   }

  var install = function(holderElement, context)
  {
     
    var textfieldid = context.getParameter("TextFieldID");
    var characterlimit = context.getParameter("CharLimit");
    var textfield = $('#'+textfieldid);
    
    $(textfield).after('<style>.textoverlimit{  color: #FF0000;  font-weight: bold;}</style><div id="charcounter' + textfieldid +'">Limit: <span id="charlimit' + textfieldid +'">0</span> characters, Remaining: <span id="charsleft' + textfieldid +'">0</span></div>');
    $("#charlimit" + textfieldid).text(characterlimit);
    $("#charsleft" + textfieldid).text(characterlimit - textfield.val().length);

    $(textfield).on('input propertychange', function(){
      $("#charlimit" + textfieldid).text(characterlimit);
      $("#charsleft" + textfieldid).text(characterlimit - textfield.val().length);

      if (characterlimit - textfield.val().length <= 0)
      {
        $("#charsleft" + textfieldid).addClass('textoverlimit');
        $("#charsleft" + textfieldid).text("0");
        imposeMaxLength(textfield, characterlimit);
      }
      else
      {
        $("#charsleft" + textfieldid).removeClass('textoverlimit');
      }
    });

  };

  var uninstall = function(holderElement, context)
  {

  };

  return {
    callbacks: {
      events: {
        // adding and removing
        install: install,
        uninstall: uninstall
      }
    }
  };
});
